#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <nicklib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>

#include "admutils.h" 

extern int *fchrom, *lchrom ;
extern Indiv **indivmarkers ; 
extern SNP **snpmarkers ;
extern int tlreest ;
extern int xchrom ;
extern double plo, phi ;
extern int markerpub ;
extern int magicnum ;

extern double muval1, tmumean ;
extern int verbose ;
extern int debug  ;
extern int keeptrashfiles ;


double HMMbeta
 (
 SNP **tsnpm,
 int indiv,
 double theta, 
 double lambda, 
 int first, 
 int last, 
 double **betas,
 double *binit, 
 int numstates, double *scale ) ;

double HMMalpha
 (
 SNP **tsnpm,  
 int indiv,
 double theta, 
 double lambda, 
 int first, 
 int last, 
 double **alphas,
 double *ainit, 
 int numstates, double *scale ) ;

void calcY(SNP **snpm, int i, int j, double *X, int numstates) ;  
void calcX(SNP **snpm, int i, int j, double *X, int numstates) ;
void calcM(double poisson, double theta, double **M, int numstates) ;

double
mk2from3(double *xd, double *xc, double p, double pp) ;

void
mk2from2(double *xd, double *xc) ;

void
putepath(SNP **snpm, int *ethnic, int fc, int lc,  int indiv)  ;


